{$I+,S+,Q+,R+}
Program Check;
var
  N, M: LongInt;
  RAns: LongInt;
  P: LongInt;
  Used: Array[1..1000] of Boolean;
  A, B, C: LongInt;
  Ans: LongInt;
  L: Array[1..1000, 1..1000] of LongInt;
  E: Array[1..1000, 1..1000] of LongInt;
  i: LongInt;

Procedure Bad;
begin
  Assign(Output, '_result.txt');
  ReWrite(Output);
  WriteLn(0);
  Close(Output);
  Halt;
end;

Procedure Ok;
begin
  Assign(Output, '_result.txt');
  ReWrite(Output);
  WriteLn(1);
  Close(Output);
  Halt;
end;

Procedure Go(num: LongInt);
var
  i: LongInt;

begin
  Used[num]:= True;
  For i:= 1 to N do
  If (E[num, i] = 1) and (not Used[i]) then
    Go(i);
end;

begin
  Assign(Input, ParamStr(1));
  ReSet(Input);
  Read(N, M);
  FillChar(L, SizeOf(L), 0);
  For i:= 1 to M do begin
    Read(A, B, C);
    L[A, B]:= C;
    L[B, A]:= C;
  end;
  Close(Input);
  Assign(Input, ParamStr(2));
  ReSet(Input);
  Read(RAns);
  Close(Input);
  Try
    Assign(Input, ParamStr(3));
    ReSet(Input);
    FillChar(E, SizeOf(E), 0);
    Read(Ans);
    If Ans <> RAns then Bad;
    Read(P);
    For i:= 1 to P do begin
      Read(A, B);
      If L[A, B] = 0 then Bad;
      If L[A, B] > Ans then Bad;
      L[A, B]:= 0;
      L[B, A]:= 0;
      E[A, B]:= 1;
      E[B, A]:= 1;
    end;
    FillChar(Used, SizeOf(Used), False);
    Go(1);
    For i:= 1 to N do
    If not Used[i] then Bad;
    Close(Input);
  Except
    Bad;
  end;
  Ok;
end.